import mathutils
import bge
import math

def update(controller):
  obj = controller.owner
  keyactive = bge.logic.keyboard.active_events

  if bge.events.LEFTARROWKEY in keyactive:
    obj["xvelocity"] -= obj["accel"]
  elif bge.events.RIGHTARROWKEY in keyactive:
    obj["xvelocity"] += obj["accel"]

  if bge.events.UPARROWKEY in keyactive:
    obj["yvelocity"] += obj["accel"]
  elif bge.events.DOWNARROWKEY in keyactive:
    obj["yvelocity"] -= obj["accel"]

  if abs(obj["xvelocity"]) < 0.5:
    obj["xvelocity"] = 0
  else:
    obj["xvelocity"] = math.copysign(min(abs(obj["xvelocity"]), obj["maxspeed"]), obj["xvelocity"])

  if abs(obj["yvelocity"]) < 0.5:
    obj["yvelocity"] = 0
  else:
    obj["yvelocity"] = math.copysign(min(abs(obj["yvelocity"]), obj["maxspeed"]), obj["yvelocity"])

  obj.worldPosition += mathutils.Vector((obj["xvelocity"]*0.05, obj["yvelocity"]*0.05, 0))

  obj["xvelocity"] *= obj["drag"]
  obj["yvelocity"] *= obj["drag"]
